/*
 *  $Id: built.h,v 1.7 2000/09/12 13:37:26 martin Exp $
 *
 *  $Log: built.h,v $
 *  Revision 1.7  2000/09/12 13:37:26  martin
 *  DO not use static for server-built on HP-UX as it does not get
 *  	exported.
 *
 *  Revision 1.6  2000/02/28 16:50:36  martin
 *  For AIX, server_built must not be static or we cannot get it in to the
 *  	shared object.
 *
 *  Revision 1.5  2000/01/13 10:02:06  martin
 *  OOPS.
 *
 *  Revision 1.4  2000/01/13 09:59:54  martin
 *  Use #ident in addition to static string.
 *
 *  Revision 1.3  2000/01/12 17:55:48  martin
 *  Add support for Sinix which optimises the server_built string out
 *  	so using #ident instead. Could use #ident on other
 *  	platforms but no time to day to test this out.
 *
 *  Revision 1.2  1998/09/23 14:10:52  martin
 *  Forgot to put an ID and Log in the header.
 *
 *
 *  This header file simply contains a character array containing
 *  the date the product was built. The C preprocessor should replace
 *  __DATE__ and __TIME__ with the actual date and time.
 *
 *  Include this file in each final executable, shared object or DLL.
 */
#if defined(__DATE__) && defined(__TIME__)
# ifdef __sinix__
#  ident "$Built: "__DATE__ " " __TIME__ " $"
# endif
# if !defined(__aix__) && !defined(__hpux__)
   static
# endif
  const char server_built[] = "$Built: "__DATE__ " " __TIME__ " $";
#else
# ifdef __sinix__
#  ident "$Built: unknown $";
# endif
# if !defined(__aix__) && !defined(__hpux__)
   static
# endif
  const char server_built[] = "$Built: unknown $";
#endif
