/*
 *  $Id: connfunc.h,v 1.12 2000/03/08 16:32:28 nick Exp $
 *
 *  $Log: connfunc.h,v $
 *  Revision 1.12  2000/03/08 16:32:28  nick
 *  Add C++ wrappers
 *
 *  Revision 1.11  2000/02/20 18:06:51  nick
 *  Temp checkin
 *
 *  Revision 1.10  2000/02/02 10:48:08  nick
 *  Add generate_connection_string_ex
 *
 *  Revision 1.9  2000/02/01 17:21:52  martin
 *  Add delete_connection_string().
 *
 *  Revision 1.8  1999/02/16 11:33:12  nick
 *  Add extra arg to generate_connection_string
 *
 *  Revision 1.7  1999/01/27 08:58:07  martin
 *  Add replace_connection_string() which replaces a keyword with another.
 *
 *  Revision 1.6  1999/01/25 12:10:55  martin
 *  Added init_con_str.
 *
 *  Revision 1.5  1999/01/25 12:09:29  nick
 *  Add functions the handle merging of lists and parsing of nested DSN's
 *
 *  Revision 1.4  1999/01/12 10:52:52  martin
 *  Add a flag PARSE_NO_DEFAULT for parse_connection_string.
 *
 *  Revision 1.3  1998/12/03 17:20:50  nick
 *  Add extra arg to generate_connection_string
 *
 *  Revision 1.2  1998/08/12 08:52:49  nick
 *  Checkpoint
 *
 *  Revision 1.1  1998/05/08 08:54:55  nick
 *  Initial revision
 *
 *
 */

#ifndef _CONNFUNC_H
#define _CONNFUNC_H

#ifdef __cplusplus
extern "C" {             /* Assume C declarations for C++   */
#endif  /* __cplusplus */

#include "memsys.h"
#include "list.h"

struct con_pair
{
    char *keyword;
    char *attribute;
    char *identifier;
};

struct con_struct
{
    int        count;
    LIST    con_list;
};

int parse_connection_string( struct con_struct *, MEMHANDLE, char *, int ,
                             unsigned long);
char * get_attribute_value( struct con_struct *, char * keyword );
char * generate_connection_string( struct con_struct * con_str, char *str, int max_len );
char * generate_connection_string_ex( struct con_struct * con_str, char *str, int max_len );
int append_pair( struct con_struct *con_str, char *kword, char *value, MEMHANDLE mh );
void merge_connection_string( struct con_struct *dest, struct con_struct *src,
        MEMHANDLE dest_mh );
void modify_connection_string( struct con_struct *cs, char *kw, char *str, MEMHANDLE mh );
void init_con_str( struct con_struct *cs);
void replace_connection_string( struct con_struct *cs, char *kw, char *new_kw, MEMHANDLE mh);
void delete_connection_string( struct con_struct *cs, char *kw, MEMHANDLE mh);
void change_connection_string( struct con_struct *cs, char *in, char *out, MEMHANDLE mh );

#define PARSE_NO_DEFAULT 0x1

#ifdef __cplusplus
}                                    /* End of extern "C" { */
#endif  /* __cplusplus */
#endif
