/*
 *  $Id: evaluate.h,v 1.11 2000/08/18 11:53:19 nick Exp $
 *
 *  $Log: evaluate.h,v $
 *  Revision 1.11  2000/08/18 11:53:19  nick
 *  Add deferred_read
 *
 *  Revision 1.10  2000/07/24 09:23:01  nick
 *  Add EVAL_NOCONSTANT
 *
 *  Revision 1.9  1999/05/17 09:28:19  nick
 *  Add can_cast_types prototype
 *
 *  Revision 1.8  1999/01/25 16:00:15  nick
 *  Add extra arg to evaluate_expr and EVAL_STOPONAND flag
 *
 *  Revision 1.7  1998/12/15 10:30:08  nick
 *  Add extra arg to compile_like
 *
 *  Revision 1.6  1998/12/03 17:21:35  nick
 *  add check_expression
 *
 *  Revision 1.5  1998/11/16 10:45:59  nick
 *  Add eval_cast function
 *
 *  Revision 1.4  1998/11/04 13:30:43  nick
 *  Merge evaluate_expr and evaluate_expr_with_cb
 *
 *  Revision 1.3  1998/09/21 14:21:46  nick
 *  Add interval support.
 *
 *  Revision 1.2  1998/08/12 08:52:49  nick
 *  Checkpoint
 *
 *  Revision 1.1  1998/05/08 08:54:56  nick
 *  Initial revision
 *
 *
 */

#ifndef _EVALUATE
#define _EVALUATE

#if defined ( WIN32 )
#include <windows.h>
#endif

#include <setjmp.h>

#include "list.h"
#include "nodes.h"
#include "parsenodes.h"
#include "execnodes.h"

struct eval_arg
{
    jmp_buf         env;
    int             retval;
    Handle_Stmt     *stmt;
    MEMHANDLE       exec_memhandle;
    /* this stops circular dependancies between functions and execute */
    void            *(*evaluate_expr)(void *, void *, void (*func)(ColumnName*,void*), void *, int );
};

#define EVAL_STOPONAND              0x01
#define EVAL_NOCONSTANT             0x02

void * evaluate_expr( void * node, void * vea, void (*func)(ColumnName *, void *), void * arg, int flags );
void null_expr( void *, int );
int init_set_value( void *, void * );
int compile_like( LikePredicate * like, MEMHANDLE mh, struct eval_arg *ea );
int check_like( LikePredicate * like, Value * v );
void evaluate_distinct_error( struct eval_arg * ea, char * sqlstate, char * txt );
void interval_operation( Value *lval, Value *rval, Value *res, struct eval_arg *ea, int op );
Value * eval_cast( CastExpression *ce, struct eval_arg * ea, Value *expr );
int check_expression( int *, void *, MEMHANDLE );
int can_cast_types( int ltype, int rtype );
int deferred_read( Value *value );

#endif
