/*
----------------------------------------------------------------------
configuration options
----------------------------------------------------------------------

         +----------------------------------------------------+
         |  Worldwide Copyright (c) Byte Designs Ltd (1998)   |    
         |                                                    |
         |               20568 - 32 Avenue                    |
         |               LANGLEY, BC                          |
         |               V3A 4P5 CANADA                       |
         |                                                    |
         | Sales: sales@byted.com  Support: support@byted.com |
         | Phone: (604) 534 0722   Fax: (604) 534 2601        |
         +----------------------------------------------------+
                            Version 6.12
 
----------------------------------------------------------------------
*/
/* configuration options - adjust as required --------------------- */

/* features */
#define ISADMIN     1                   /* global administration */
#define ISAUDIT     1                   /* 0:off 1:standard */
#define ISLOGGING   1                   /* 0:off 1:standard */
#define ISVARIABLE  2                   /* 0:off 1:std 2:pack */
#define ISLOCKING   2                   /* 0:off 1:old 2:std 3:lck */
#define ISDUPLOCKS  1                   /* honour locks in dup opens */
#define ISDECLARE   1                   /* declare parameters */
#define ISDATAVOID  0                   /* void data pointers */
#define ISCUSTOM    0                   /* include custom extensions */
#define ISBERKELY   0                   /* 0:memcpy() 1: bcopy() */
#define ISMFCOBOL   0                   /* 0:.dat 1:check for no extension */
#define ISHUGE      0                   /* 0:off 1:hp-ux */

/* values */
#define ISIDXBLK    1024                /* default index block size */
#define ISDUPLEN    4                   /* default duplicate width */
#define ISMAXIDX    25                  /* indexes per file */
#define ISMAXPARTS  25                  /* parts per key */
#define ISMAXKEY    512                 /* bytes per key */
#define ISMAXBUF    20                  /* buffers per index */
#define ISERRBASE   100                 /* start error codes at */

/* platform specific locking function return values -------------------*/
#if defined( __solaris )\
    || defined( __linux )
#define ISLKFAIL         EAGAIN
#else
#define ISLKFAIL         EACCES
#endif

#if defined(  __aix )\
    || defined( __hpux__ )\
    || defined( __linux )\
    || defined( __osf )\
    || defined( __freebsd )
#define ISLKDEAD         EDEADLK
#else
#define ISLKDEAD         EDEADLOCK
#endif

/* set for C-ISAM compatible behaviours -------------------------------*/
#define C7NOWAIT 0                       /* 0: default  1: no-wait     */

/* setfor C-ISAM 5.0 -> 7.1 locking concurrency -----------------------*/
#define C7LOCKING 0                      /* 0: disam/cisam pre 5.0     */
                                         /* 1: cisam 5.0 > 7.1         */

/* threadsafe configuration -------------------------------------- */

/* 0 - disabled
   1 - SunOS
   2 - Solaris
   5 - pthreads */
  
#ifdef _WITH_THREADS
#define ISTHREADED  5
#else
#define ISTHREADED  0
#endif

/* the rest are internals ---------------------------------------- */
#define ISMODE      0666                /* full access */

/* not configurable */
#define ISDYNAMIC   0                   /* not available */
#define ISMIFCODE   0                   /* not available */

/* conflicting options check */
#if( ISLOGGING > 0 && ISADMIN == 0 )
#pragma error /* logging requires the administration facility */
#endif

