/*
 *  $Id: numeric.h,v 1.4 1999/12/20 13:09:50 nick Exp $
 *
 *  $Log: numeric.h,v $
 *  Revision 1.4  1999/12/20 13:09:50  nick
 *  Use int64_t
 *
 *  Revision 1.3  1999/03/17 17:17:57  nick
 *  Add struct eval to div_numeric
 *
 *  Revision 1.2  1999/02/24 11:49:20  nick
 *  Change the value of NUMERIC_MINUS from 2 to 0
 *
 *  Revision 1.1  1998/10/20 09:29:26  nick
 *  Initial revision
 *
 *
 */

#ifndef _NUMERIC
#define _NUMERIC

#define NUM_SUCCESS			0
#define NUM_PRECISION_LOST	1
#define NUM_TRUNCATED		-1	
#define NUM_OVERFLOW        -2

#define NUMERIC_PLUS		1
#define NUMERIC_MINUS		0

/*
 * get the struct eval_arg definition
 */

#include "evaluate.h"

int int_to_numeric( int i, SQL_NUMERIC_STRUCT *num, int precision, int scale );
int numeric_to_int( SQL_NUMERIC_STRUCT *num, int *i );
int bigint_to_numeric( int64_t bi, SQL_NUMERIC_STRUCT *num, int precision, int scale );
int numeric_to_bigint( SQL_NUMERIC_STRUCT *num, int64_t *bi );
int double_to_numeric( double d, SQL_NUMERIC_STRUCT *num, int precision, int scale );
int numeric_to_double( SQL_NUMERIC_STRUCT *num, double *d );
int numeric_to_string( SQL_NUMERIC_STRUCT *num, char *str, int max_len, 
	SQLINTEGER *actual_len );
int numeric_compare( SQL_NUMERIC_STRUCT *n1, SQL_NUMERIC_STRUCT *n2 );
int add_numeric( SQL_NUMERIC_STRUCT *n1, SQL_NUMERIC_STRUCT *n2 );
int subtract_numeric( SQL_NUMERIC_STRUCT *n1, SQL_NUMERIC_STRUCT *n2 );
int create_numeric( char *str, SQL_NUMERIC_STRUCT *num, int precision, int scale );
int string_to_numeric( char *str, SQL_NUMERIC_STRUCT *num, int precision, int scale );
int mult_numeric(  SQL_NUMERIC_STRUCT *n1, SQL_NUMERIC_STRUCT *n2 );
int div_numeric(  SQL_NUMERIC_STRUCT *n1, SQL_NUMERIC_STRUCT *n2, struct eval_arg *ea );

#endif
