/*
 *  $Id: sqi.h,v 1.16 2000/11/14 17:43:30 nick Exp $
 *
 *  $Log: sqi.h,v $
 *  Revision 1.16  2000/11/14 17:43:30  nick
 *  Add IS NUL support
 *
 *  Revision 1.15  2000/09/19 12:48:34  nick
 *  Add SQI_INFO_OOO_GD
 *
 *  Revision 1.14  2000/07/10 15:18:58  nick
 *  Add 4 part names
 *
 *  Revision 1.13  2000/06/19 08:39:09  nick
 *   Add 1.4 support code
 *
 *  Revision 1.12  2000/06/05 08:20:01  nick
 *  Add passthriugh support
 *
 *  Revision 1.11  2000/02/15 12:07:47  nick
 *  Add Procedure support
 *
 *  Revision 1.10  2000/01/12 13:52:46  nick
 *  Add DSN to DALOpen
 *
 *  Revision 1.9  1999/04/16 08:22:41  nick
 *  Add extra args to StartQuery
 *
 *  Revision 1.8  1999/02/26 11:45:12  nick
 *  Add weighting info call
 *
 *  Revision 1.7  1999/02/22 09:54:33  nick
 *  Add prototypes for SQIDropColumn and SQIAddColumn
 *
 *  Revision 1.6  1999/02/16 13:06:12  nick
 *  Update some prototypes
 *
 *  Revision 1.5  1999/02/16 12:48:07  nick
 *  Remove ScoreQuery
 *
 *  Revision 1.4  1998/11/20 13:20:38  nick
 *  Add SQIScoreQuery
 *
 *  Revision 1.3  1998/11/10 17:08:11  nick
 *  Add SQL_SUCCESS_WITH_INFO
 *
 *  Revision 1.2  1998/10/20 09:31:59  nick
 *  Added concurrency support
 *
 *  Revision 1.1  1998/08/12 08:52:49  nick
 *  Initial revision
 *
 */

#ifndef _SQI_H
#define _SQI_H

#include "connfunc.h"
#include "dal.h"

#define SQIHANDLE                   DALHANDLE
#define SQIITERATOR                 DALITERATOR
#define SQIPARSEHANDLE              DALPARSEHANDLE

#define SQI_ERROR                   DAL_ERROR
#define SQI_SUCCESS                 DAL_SUCCESS
#define SQI_SUCCESS_WITH_INFO       DAL_SUCCESS_WITH_INFO
#define SQI_TABLE_NOT_FOUND         DAL_TABLE_NOT_FOUND
#define SQI_NO_DATA                 DAL_NO_DATA
#define SQI_LOCKED                  DAL_LOCKED

#define SQI_INDEX_UNIQUE            DAL_INDEX_UNIQUE
#define SQI_INDEX_NONUNIQUE         DAL_INDEX_NONUNIQUE
#define SQI_INDEX_DESC              DAL_INDEX_DESC
#define SQI_INDEX_ASC               DAL_INDEX_ASC

#define SQICOLUMNINFO               DALCOLUMNINFO
#define SQIPROCINFO                 DALPROCINFO
#define SQIARGINFO                  DALARGINFO

#define SQIColumnDefinitions        DALColumnDefinitions
#define SQITableDefinitions         DALTableDefinitions
#define SQIIndexDefinition          DALIndexDefinition
#define SQIPrivDefinition           DALPrivDefinition

#define SQI_INFO_GET_QUAL_MASK      DAL_INFO_GET_QUAL_MASK
#define SQI_INFO_QUAL_TWO_COL       DAL_INFO_QUAL_TWO_COL
#define SQI_INFO_QUAL_LIKE          DAL_INFO_QUAL_LIKE
#define SQI_INFO_QUAL_NULL          DAL_INFO_QUAL_NULL

#define SQI_INFO_GET_WEIGHTING      DAL_INFO_GET_WEIGHTING
#define SQI_INFO_HAS_NUMERICS       DAL_INFO_HAS_NUMERICS
#define SQI_INFO_OOO_GD             DAL_INFO_OOO_GD

int SQIOpen( SQLHANDLE, SQIHANDLE *, HELPERFUNC hf, char *dsn );
int SQIClose( SQIHANDLE );
int SQIConnect( SQIHANDLE, struct con_struct *, void *, char *, int );
int SQIDisconnect( SQIHANDLE );
int SQIGetInfo( SQIHANDLE, int info, void * data );
int SQISetInfo( SQIHANDLE, int info, void * data );
int SQIGetTableInfo( SQLHANDLE, SQIHANDLE, char *, char *, char *, SQITABLEINFO * );
int SQIGetColumnInfo( SQLHANDLE, SQIHANDLE, char *, char *, char *, int, SQICOLUMNINFO * );
int SQIGetProcInfo( SQLHANDLE, DALHANDLE, char *, char *, char *, SQIPROCINFO * );
int SQIGetArgInfo( SQLHANDLE, SQIHANDLE, char *, char *, 
      char *, int, SQIARGINFO * );
SQIITERATOR SQIOpenIterator( SQLHANDLE, SQIHANDLE );
void SQICloseIterator( SQIITERATOR );
void SQIResetIterator( SQIITERATOR );
int SQIFetch( SQIITERATOR );
int SQITables( SQIITERATOR, char *, int, char *, int, char *, int, char *, int );
int SQIColumns( SQIITERATOR, char *, int, char *, int, char *, int, char *, int );
int SQIColumnPrivileges( SQIITERATOR, char *, int, char *, int, char *, int, char *, int );
int SQIPrimaryKeys( SQIITERATOR, char *, int, char *, int, char *, int );
int SQISpecialColumns( SQIITERATOR, int, char *, int, char *, int, char *, int, int, int );
int SQIStatistics( SQIITERATOR, char *, int, char *, int, char *, int, int, int );
int SQIForeignKeys( SQIITERATOR, char *, int, char *, int, char *, int, char *, int,
    char *, int, char *, int );
int SQITablePrivileges( SQIITERATOR, char *, int, char *, int, char *, int );
int SQIGetData( SQIITERATOR vdi, int, int, void *, int, long * );
int SQIStartQuery( SQIITERATOR, SQITABLEINFO *, SQICOLUMNINFO *, int *, int, QueryQualifier ** );
int SQIGetTypeInfo( SQIITERATOR, int );
int SQICreateTable( SQIITERATOR, SQITABLEINFO *, int, SQIColumnDefinitions *,
        int, SQIColumnDefinitions *, int, SQITableDefinitions * );
int SQIDropTable( SQIITERATOR, SQITABLEINFO * );
int SQIDropIndex( SQIITERATOR, SQITABLEINFO * );
int SQICreateIndex( SQIITERATOR, SQITABLEINFO *, SQITABLEINFO *, int, int, 
    SQIIndexDefinition * );
int SQITablePKInfo( SQLHANDLE, SQIITERATOR, char *, char *, char *, int, SQIIndexDefinition *, 
        SQITABLEINFO *, SQICOLUMNINFO * );
int SQIFetchRow( SQIITERATOR, SQITABLEINFO *, int, QueryQualifier *, int lock_mode,
        void *concur_buffer);
int SQIInsert( SQIITERATOR, SQITABLEINFO *, int, QueryQualifier *, int * change_count );
int SQIDeleteRow( SQIITERATOR, SQITABLEINFO *, int, QueryQualifier *, int * change_count );
int SQIUpdateRow( SQIITERATOR, SQITABLEINFO *, int, QueryQualifier *,
    int, QueryQualifier *, int * change_count );
int SQIStartTransaction( SQLHANDLE, SQIHANDLE );
int SQIEndTransaction( SQLHANDLE, SQIHANDLE, int mode );
int SQIGrant( SQIITERATOR, SQITABLEINFO *, SQIPrivDefinition * );
int SQIRevoke( SQIITERATOR, SQITABLEINFO *, SQIPrivDefinition * );
int SQIDropColumn( SQIITERATOR, SQITABLEINFO *, char *, int );
int SQIAddColumn( SQIITERATOR, SQITABLEINFO *, int, SQIColumnDefinitions * );
int SQIAddConstraint( SQIITERATOR, SQITABLEINFO *,
        int, SQIColumnDefinitions *, int, SQITableDefinitions * );
int SQIProcedures( SQIITERATOR, char *, int, char *, int, char *, int );
int SQIProcedureColumns( SQIITERATOR, char *, int, char *, int, char *, int, char *, int );
int SQICallProcedure( SQIITERATOR, SQIPROCINFO *, SQIARGINFO *, int, QueryQualifier *, int, QueryQualifier *, int * );
int SQICreateUser( DALITERATOR, char *, char * );
int SQIDropUser( DALITERATOR, char * );

/*
 * new pass through funcs
 */

int SQIExecute( SQLHANDLE sh, DALHANDLE dh, DALTABLEINFO * dti );
int SQIPrepare( SQIITERATOR, SQITABLEINFO*, SQIPARSEHANDLE, int, int * );

#endif
