/*
 *  $Id: sql92parse.h,v 1.6 2000/07/18 09:46:16 nick Exp $
 *
 *  $Log: sql92parse.h,v $
 *  Revision 1.6  2000/07/18 09:46:16  nick
 *  Add extra args to sql92_parse
 *
 *  Revision 1.5  2000/02/15 12:07:47  nick
 *  Add Procedure support
 *
 *  Revision 1.4  1999/03/17 17:19:04  nick
 *  Add sql92_indatatype lex tyin.
 *
 *  Revision 1.3  1999/02/16 11:41:39  nick
 *  Add proto for sql92string_replicate
 *
 *  Revision 1.2  1998/08/12 08:52:49  nick
 *  Checkpoint
 *
 *  Revision 1.1  1998/05/08 08:54:56  nick
 *  Initial revision
 *
 *
 */

/* definition for the parser interface */

#ifndef _SQL92PARSE_H
#define _SQL92PARSE_H

#include "sysdefs.h"
#include "memsys.h"

typedef void (*CBFUNC)(void*,void*);
typedef void (*OPF)(char*, void*);

typedef struct ParseHandle
{
    void     *sql_tree;
    void     *mem_handle;
    void     *parent;
    char     szerror[ 256 ];
    int      param_count;
    int      save_param;
    int      qualifier_count;
    void     **vqq;
} * PARSEHANDLE;

PARSEHANDLE sql92_alloc_handle( MEMHANDLE parent );
void sql92_free_handle( PARSEHANDLE p );
int sql92_parse( PARSEHANDLE p, char * sql, int qualifier_count, void ** qualifiers );
char * sql92_geterror( PARSEHANDLE p );
void sql92_dump( PARSEHANDLE p, OPF, void * );
int sql92_validate( SQLHANDLE stmt );
char * sql92string_replicate( const char * str );

/* these are in the coresponding lex code */

int sql92lex( void );
void sql92_infunction( int state );
void sql92_indatatype( int state );
void * lex_setup_string( char * str );
void lex_shutdown();

#endif
