/*
 *  $Id: tree.h,v 1.2 1998/08/12 08:52:49 nick Exp $
 *
 *  $Log: tree.h,v $
 *  Revision 1.2  1998/08/12 08:52:49  nick
 *  Checkpoint
 *
 *  Revision 1.1  1998/05/08 08:54:56  nick
 *  Initial revision
 *
 *
 */

#ifndef _TREE_H
#define _TREE_H

#define TREE_NOERROR        0
#define TREE_BADARG            1
#define TREE_NOMEM            2
#define TREE_NOTFOUND        3    

typedef int ( * PFNCOMPARE )( int k1Len, void * k1, int k2Len, void * k2 );
typedef void * ( * PFNALLOCATE )( void * data );
typedef void ( * PFNFREE )( void * node );

typedef void * TREEHANDLE;

int TREEnew( TREEHANDLE * Tree,
    int Flags,
    PFNCOMPARE pfnCompare,
    PFNALLOCATE pfnAllocate,
    PFNFREE pfnFree,
    void * mh );

int TREEdelete( TREEHANDLE Tree );

int TREEinsert( TREEHANDLE Tree,
    void * Key,
    int KeyLen,
    void * Data );

int TREElookup( TREEHANDLE Tree,
    void * Key,
    int KeyLen,
    void ** pData );

#endif
